# Class VulkanExtensionProperties.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanExtensionProperties.Builder

Enclosing class:
  `VulkanExtensionProperties`

public static final class VulkanExtensionProperties.Builder extends Object
Builds instances of type `VulkanExtensionProperties`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanExtensionProperties`
  `build()`
  Builds a new `VulkanExtensionProperties`.
  `final VulkanExtensionProperties.Builder`
  `from(VulkanExtensionPropertiesType instance)`
  Fill a builder with attribute values from the provided `VulkanExtensionPropertiesType` instance.
  `final VulkanExtensionProperties.Builder`
  `setName(String name)`
  Initializes the value for the `name` attribute.
  `final VulkanExtensionProperties.Builder`
  `setVersion(int version)`
  Initializes the value for the `version` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanExtensionProperties.Builder from(VulkanExtensionPropertiesType instance)
    Fill a builder with attribute values from the provided `VulkanExtensionPropertiesType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setName

    public final VulkanExtensionProperties.Builder setName(String name)
    Initializes the value for the `name` attribute.
    Parameters:
      `name` - The value for name
    Returns:
      `this` builder for use in a chained invocation

  - ### setVersion

    public final VulkanExtensionProperties.Builder setVersion(int version)
    Initializes the value for the `version` attribute.
    Parameters:
      `version` - The value for version
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanExtensionProperties build()
    Builds a new `VulkanExtensionProperties`.
    Returns:
      An immutable instance of VulkanExtensionProperties
    Throws:
      `IllegalStateException` - if any required attributes are missing